unit joseabout;

{$include ..\MiLibreria\mismacros.pas}

{$define ANCHOVENTANAJA:=330}
{$define ALTOVENTANAJA:=460}
{$define MARGENSEPARACION:=25}
{$define IDBOTONEMAIL:=10000}
{$define IDBOTONDONACION:=10001}
{$define IDBOTONMISPROGRMAS:=10002}

interface

uses windows, milibreria;
procedure JoseAboutF(hventanamadre:HWND;NumVersion:PWideChar;NombreExe:PWideChar);
function JAOnCreate(hw:HWND;wp:WPARAM;lp:LPARAM):LRESULT;

implementation
function JAOnCommandMisProgramas(hw:HWND;wp:WPARAM;lp:LPARAM):LRESULT;
begin
  if ShellExecuteW(0, PWideChar(WideString('open')),
                   PWideChar(WideString('http://joseantonio.comule.com')),
                   nil, PWideChar(WideString('.')), SW_SHOWMAXIMIZED) < 32 then
    MiMostrarError(WideString({$INCLUDE %FILE%}),  WideString({$INCLUDE %LINE%}));
  Exit(0);

end;
function JAOnCommandDonate(hw:HWND;wp:WPARAM;lp:LPARAM):LRESULT;
begin
  if ShellExecuteW(0, PWideChar(WideString('open')),
                   PWideChar(WideString('https://www.paypal.com/webapps/mpp/send-money-online')),
                   nil, PWideChar(WideString('.')), SW_SHOWMAXIMIZED) < 32 then
    MiMostrarError(WideString({$INCLUDE %FILE%}),  WideString({$INCLUDE %LINE%}));
  Exit(0);

end;
function JAOnCommandEmail(hw:HWND;wp:WPARAM;lp:LPARAM):LRESULT;
begin
  if ShellExecuteW(0, PWideChar(WideString('open')),
                   PWideChar(WideString('mailto:joselopezcano@yahoo.es')),
                   nil, PWideChar(WideString('.')), SW_SHOWMAXIMIZED) < 32 then
    MiMostrarError(WideString({$INCLUDE %FILE%}),  WideString({$INCLUDE %LINE%}));
  Exit(0);
end;

function JAOnCommand(hw:HWND;wp:WPARAM;lp:LPARAM):LRESULT;
begin
  if LOWORD(wp) = IDBOTONMISPROGRMAS then
    Exit(JAOnCommandMisProgramas(hw, wp, lp));
  if LOWORD(wp) = IDBOTONDONACION then
    Exit(JAOnCommandDonate(hw, wp, lp));
  if LOWORD(wp) = IDBOTONEMAIL then
    Exit(JAOnCommandEmail(hw, wp, lp));
  Exit(1);
end;

function jafunciondeventana(hwnd:HWND;mensaje:UINT;wp:WPARAM;lp:LPARAM):LRESULT;stdcall;
begin
  if mensaje = WM_COMMAND then
    Exit(JAOnCommand(hwnd, wp, lp));
  if mensaje = WM_CREATE then
    Exit(JAOnCreate(hwnd, wp, lp));
  if mensaje = WM_DESTROY then
  begin
    PostQuitMessage(0);
    Exit(0);
  end;
  Exit(DefWindowProcW(hwnd, mensaje, wp, lp));
end;

procedure JoseAboutF(hventanamadre:HWND;NumVersion:PWideChar;NombreExe:PWideChar);
var
  hig:HICON;
  hip:HICON;
  hcur:HCURSOR;
  wc:WNDCLASSEXW;
  clna:WideString = 'JoseAboutF1';
  hw:HWND;
  hi:HMODULE;
  cadena:array [0..400] of WideChar;

begin
  lstrcpyW(PWideChar(cadena), IdiomasObtenerTexto(19));
  lstrcatW(PWideChar(cadena), WideString(' '));
  lstrcatW(PWideChar(cadena), NumVersion);
  lstrcatW(PWideChar(cadena), WideString(' '));
  lstrcatW(PWideChar(cadena), IdiomasObtenerTexto(20));
  lstrcatW(PWideChar(cadena), WideString(' '));
  lstrcatW(PWideChar(cadena), NombreExe);

  hi := GetModuleHandle(nil);
  if hi = 0 then
    MiMostrarError(WideString({$INCLUDE %FILE%}),  WideString({$INCLUDE %LINE%}));
  hig := LoadIcon(0, IDI_QUESTION);
  if hig = 0 then
    MiMostrarError(WideString({$INCLUDE %FILE%}),  WideString({$INCLUDE %LINE%}));
  hcur := LoadCursor(0, IDC_ARROW);
  if hcur = 0 then
    MiMostrarError(WideString({$INCLUDE %FILE%}),  WideString({$INCLUDE %LINE%}));
  hip := LoadIcon(0, IDI_QUESTION);
  if hip = 0 then
    MiMostrarError(WideString({$INCLUDE %FILE%}),  WideString({$INCLUDE %LINE%}));
  MiSetWindowClass(@wc, CS_HREDRAW Or CS_VREDRAW, @jafunciondeventana,
                   hig, hcur, HBRUSH(COLOR_BTNFACE + 1),
                   nil,PWideChar(clna),
                   hip);
  hw := CreateWindowExW(0, PWideChar(clna), PWideChar(cadena),
                       WS_CAPTION Or WS_SYSMENU,
                       CW_USEDEFAULT, CW_USEDEFAULT,
                       ANCHOVENTANAJA, ALTOVENTANAJA,
                       hventanamadre, 0, hi, nil);
  if hw = 0 then
    MiMostrarError(WideString({$INCLUDE %FILE%}),  WideString({$INCLUDE %LINE%}));
  if MoveWindow(hw,
             LongInt((GetSystemMetrics(SM_CXMAXIMIZED)- ANCHOVENTANAJA)div 2),
             LongInt((GetSystemMetrics(SM_CYMAXIMIZED) - ALTOVENTANAJA) div 2),
             ANCHOVENTANAJA, ALTOVENTANAJA, TRUE) = LongBool(0) then
    MiMostrarError(WideString({$INCLUDE %FILE%}),  WideString({$INCLUDE %LINE%}));
  ShowWindow(hw, SW_SHOW);
  MiBucleMensajes();
  UnregisterClassW(PWideChar(clna), hi);
  SetForegroundWindow(hventanamadre);
end;
function JAOnCreate(hw:HWND;wp:WPARAM;lp:LPARAM):LRESULT;
var
  hi:HMODULE;
  rec:RECT;
  hs:HWND;
  mensaj:array [0..2600] of WideChar;
begin
  lstrcpyW(PWideChar(mensaj), IdiomasObtenerTexto(6));
  lstrcatW(PWideChar(mensaj), WideString(#13 + #10 + #13 + #10 + #13 + #10));
  lstrcatW(PWideChar(mensaj), IdiomasObtenerTexto(7));
  lstrcatW(PWideChar(mensaj), WideString(#13 + #10 + #9));
  lstrcatW(PWideChar(mensaj), IdiomasObtenerTexto(8));
  lstrcatW(PWideChar(mensaj), WideString(#13 + #10 + #13 + #10));
  lstrcatW(PWideChar(mensaj), IdiomasObtenerTexto(9));
  lstrcatW(PWideChar(mensaj), WideString(#13 + #10 + #9));
  lstrcatW(PWideChar(mensaj), IdiomasObtenerTexto(10));
  lstrcatW(PWideChar(mensaj), WideString(#13 + #10 + #13 + #10));
  lstrcatW(PWideChar(mensaj), IdiomasObtenerTexto(11));
  lstrcatW(PWideChar(mensaj), WideString(#13 + #10 + #9));
  lstrcatW(PWideChar(mensaj), IdiomasObtenerTexto(12));
  lstrcatW(PWideChar(mensaj), WideString(#13 + #10 + #13 + #10));
  lstrcatW(PWideChar(mensaj), IdiomasObtenerTexto(13));
  lstrcatW(PWideChar(mensaj), WideString(#13 + #10 + #9));
  lstrcatW(PWideChar(mensaj), IdiomasObtenerTexto(14));
  lstrcatW(PWideChar(mensaj), WideString(#13 + #10 + #13 + #10));
  lstrcatW(PWideChar(mensaj), IdiomasObtenerTexto(15));
  lstrcatW(PWideChar(mensaj), WideString(#13 + #10 + #9));
  lstrcatW(PWideChar(mensaj), IdiomasObtenerTexto(16));

  hi := GetModuleHandle(nil);
  if hi = 0 then
    MiMostrarError(WideString({$INCLUDE %FILE%}),  WideString({$INCLUDE %LINE%}));
  if GetClientRect(hw, @rec) = LongBool(0) then
    MiMostrarError(WideString({$INCLUDE %FILE%}),  WideString({$INCLUDE %LINE%}));
  hs := CreateWindowExW(0, PWideChar(WideString('static')), PWideChar(mensaj),
                        WS_VISIBLE Or WS_CHILD Or SS_LEFT,
                        MARGENSEPARACION, MARGENSEPARACION,
                        (rec.right - rec.left) - (MARGENSEPARACION * 2),
                        (rec.bottom - rec.top) - (MARGENSEPARACION * 6),
                        hw, 0,
                        hi, nil);
  if hs = 0 then
    MiMostrarError(WideString({$INCLUDE %FILE%}),  WideString({$INCLUDE %LINE%}));
  MiPonerFuenteGui(hs);

  hs := CreateWindowExW(0, PWideChar(WideString('button')), IdiomasObtenerTexto(31),
                        WS_VISIBLE Or WS_CHILD Or BS_PUSHBUTTON,
                        MARGENSEPARACION,
                        rec.bottom - (MARGENSEPARACION * 6) ,
                        (rec.right - rec.left) - (MARGENSEPARACION * 2),
                        MARGENSEPARACION,
                        hw, HMENU(IDBOTONMISPROGRMAS),
                        hi, nil);
  if hs = 0 then
    MiMostrarError(WideString({$INCLUDE %FILE%}),  WideString({$INCLUDE %LINE%}));
  MiPonerFuenteGui(hs);
  hs := CreateWindowExW(0, PWideChar(WideString('button')), IdiomasObtenerTexto(17),
                        WS_VISIBLE Or WS_CHILD Or BS_PUSHBUTTON,
                        MARGENSEPARACION,
                        rec.bottom - (MARGENSEPARACION * 4) ,
                        (rec.right - rec.left) - (MARGENSEPARACION * 2),
                        MARGENSEPARACION,
                        hw, HMENU(IDBOTONEMAIL),
                        hi, nil);
  if hs = 0 then
    MiMostrarError(WideString({$INCLUDE %FILE%}),  WideString({$INCLUDE %LINE%}));
  MiPonerFuenteGui(hs);
  hs := CreateWindowExW(0, PWideChar(WideString('button')), IdiomasObtenerTexto(18),
                        WS_VISIBLE Or WS_CHILD Or BS_PUSHBUTTON,
                        MARGENSEPARACION,
                        rec.bottom - (MARGENSEPARACION * 2) ,
                        (rec.right - rec.left) - (MARGENSEPARACION * 2),
                        MARGENSEPARACION,
                        hw, HMENU(IDBOTONDONACION),
                        hi, nil);
  if hs = 0 then
    MiMostrarError(WideString({$INCLUDE %FILE%}),  WideString({$INCLUDE %LINE%}));
  MiPonerFuenteGui(hs);

  Exit(1);
end;

end.

