unit managedates;

{$include ..\MiLibreria\mismacros.pas}
{$define ANCHOVENTANAMD:=680}
{$define ALTOVENTANAMD:=320}
{$define SEPARACIONMD:=20}
{$define IDTABANIADIR:=10022}
{$define ANCHODATE:=240}
{$define ANCHOTIME:=80}
{$define ANCHOBOTONMD:=100}
{$define IDBOTONACEPTAR:=10023}
{$define IDBOTONCANCELAR:=10024}
{$define IDTABBORRAR:=10025}


interface

uses
  windows, milibreria, commctrl, sysutils, misqlite;

  procedure mdmanejarFechas(hvenmad:HWND);

implementation

var htabcontrol:HWND;
var hedcontrol:HWND;
var hstatic1:HWND;
var hgrupbox:HWND;
var hfecbot:HWND;
var hwdatepick1:HWND;
var hwdatepick2:HWND;
var hultnoch:HWND;

var hstatic2:HWND;
var hcombobox:HWND;

var hbotacep:HWND;
var hbotcanc:HWND;

procedure mdQuitarFecha(hw:HWND);
var
    descr:PWideChar;
    hle:dword;
begin
     if SendMessageW(hcombobox, CB_GETCOUNT, 0, 0) < 1 then
     begin
          MessageBoxW(hw, IdiomasObtenerTexto(1000012),
                IdiomasObtenerTexto(1000003),
                MB_OK or MB_ICONWARNING);
     end;
     descr := Mimalloc(1000 * sizeof(WCHAR));
     SendMessageW(hcombobox, WM_GETTEXT, 999, LPARAM(descr));
     hle := WAIT_TIMEOUT;
     while hle = WAIT_TIMEOUT do
       hle := WaitForSingleObject(puedo, 70);
     sqQuitarFecha(descr);
     ReleaseMutex(puedo);
     Mifree(descr);
end;

procedure mdMostrarBorrar(x:integer);
begin
  ShowWindow(hstatic2, x);
  ShowWindow(hcombobox, x);
end;
procedure mdMostrarAniadir(x:integer);
begin
  ShowWindow(hedcontrol, x);
  ShowWindow(hstatic1, x);
  ShowWindow(hgrupbox, x);
  ShowWindow(hfecbot, x);
  ShowWindow(hwdatepick1, x);
  ShowWindow(hwdatepick2, x);
  ShowWindow(hultnoch, x);
end;
function mdOnNotifytab(hw:HWND;wp:WPARAM;lp:LPARAM):LRESULT;
var x:integer;
var p:^NMHDR;
begin
  p := PVOID(lp);
  if ULONG(p^.code) = ULONG(TCN_SELCHANGING) then
    Exit(0);
  if ULONG(p^.code) <> ULONG(TCN_SELCHANGE) then
    Exit(1);
  x := SendMessage(htabcontrol, TCM_GETCURSEL, 0, 0);
  if x = -1 then
     MiMostrarError(WideString({$INCLUDE %FILE%}), WideString({$INCLUDE %LINE%}));
  if x = 0 then
  begin
    mdMostrarAniadir(SW_SHOW);
    mdMostrarBorrar(SW_HIDE);
  end;
  if x = 1 then
  begin
    mdMostrarBorrar(SW_SHOW);
    mdMostrarAniadir(SW_HIDE);
  end;
  Exit(0);
end;

function mdonNotify(hw:HWND;wp:WPARAM;lp:LPARAM):LRESULT;
var x:integer;
var p:^NMHDR;
begin
  p := PVOID(lp);
  if HWND(p^.hwndFrom) = HWND(htabcontrol) then
    Exit(mdOnNotifytab(hw, wp, lp));
  Exit(1);
end;

function mdEsUnoFijo(pcadena:PWideChar):boolean;
var x:DWORD;
begin
  for x := 1100000 to 1100003 do
  begin
    if Miwcscmp(IdiomasObtenerTexto(x), pcadena) = 0 then
      Exit(true);
  end;
  Exit(false);
end;

procedure mdAddDesc(hw:HWND);
var lon:integer;
var ptext:Pointer;
var systim:SYSTEMTIME;
var systim2:SYSTEMTIME;
var hle:dword;
begin
  lon := SendMessageW(hedcontrol, WM_GETTEXTLENGTH, 0, 0);
  if lon = 0 then
  begin
    MessageBoxW(hw, IdiomasObtenerTexto(1000009),
                IdiomasObtenerTexto(1000003),
                MB_OK or MB_ICONWARNING);
    Exit();
  end;
  ptext := Mimalloc((lon + 1) * sizeof(WCHAR));
  if ptext = nil then
         MiMostrarError(WideString({$INCLUDE %FILE%}), WideString({$INCLUDE %LINE%}));
  SendMessageW(hedcontrol, WM_GETTEXT, lon + 1, LongInt(ptext));
  Mitrim(ptext);
  if Miwcslen(ptext) < 1 then
  begin
    MessageBoxW(hw, IdiomasObtenerTexto(1000009),
                IdiomasObtenerTexto(1000003),
                MB_OK or MB_ICONWARNING);
    Exit();
  end;
  if mdEsUnoFijo(ptext) = true then
  begin
    MessageBoxW(hw, IdiomasObtenerTexto(1000010),
                IdiomasObtenerTexto(1000003),
                MB_OK or MB_ICONWARNING);
    Exit();
  end;
  hle := WAIT_TIMEOUT;
  while hle = WAIT_TIMEOUT do
    hle := WaitForSingleObject(puedo, 70);
  if sqObtenerFechaDeDescripcion(systim, ptext) = true then
  begin
    MessageBoxW(hw, IdiomasObtenerTexto(1000010),
                IdiomasObtenerTexto(1000003),
                MB_OK or MB_ICONWARNING);

    ReleaseMutex(puedo);
    Exit();
  end;
  ReleaseMutex(puedo);
  if SendMessageW(hwdatepick1, DTM_GETSYSTEMTIME, 0, LongInt(@systim)) = GDT_ERROR then
         MiMostrarError(WideString({$INCLUDE %FILE%}), WideString({$INCLUDE %LINE%}));
  if SendMessageW(hwdatepick2, DTM_GETSYSTEMTIME, 0, LongInt(@systim2)) = GDT_ERROR then
         MiMostrarError(WideString({$INCLUDE %FILE%}), WideString({$INCLUDE %LINE%}));
  systim.Hour:= 0;
  systim.Minute:= 0;
  systim.Second:= 0;
  systim.Millisecond:= 0;
  if SendMessageW(hfecbot, BM_GETCHECK, 0, 0) = BST_CHECKED then
  begin
    systim.Hour:= systim2.Hour;
    systim.Minute:= systim2.Minute;
    systim.Second:= systim2.Second;
    systim.Millisecond:= systim2.Millisecond;
  end;
  hle := WAIT_TIMEOUT;
  while hle = WAIT_TIMEOUT do
    hle := WaitForSingleObject(puedo, 70);
  sqAniadirFecha(systim, ptext);
  ReleaseMutex(puedo);
  Mifree(ptext);
end;
{----------------------------------------------------------}
function mdOnCommandAceptar(hw:HWND;wp:WPARAM;lp:LPARAM):LRESULT;
var sel:integer;
begin
  sel := SendMessageW(htabcontrol, TCM_GETCURSEL, 0, 0);
  if sel = -1 then
    MiMostrarError(WideString({$INCLUDE %FILE%}), WideString({$INCLUDE %LINE%}));
  if sel = 0 then
  begin
    mdAddDesc(hw);
    DestroyWindow(hw);
  end;
  if sel = 1 then
    mdQuitarFecha(hw);
    DestroyWindow(hw);
  Exit(0);
end;
{---------------------------------------------------------}
function mdOnCommandCancelar(hw:HWND;wp:WPARAM;lp:LPARAM):LRESULT;
begin
  DestroyWindow(hw);
  Exit(0);
end;

function mdonCommand(hw:HWND;wp:WPARAM;lp:LPARAM):LRESULT;
begin
  if LOWORD(wp) = IDBOTONACEPTAR then
    Exit(mdOnCommandAceptar(hw, wp, lp));
  if LOWORD(wp) = IDBOTONCANCELAR then
    Exit(mdOnCommandCancelar(hw, wp, lp));
  Exit(1);
end;
{---------------------------------------------------------}
function mdonCreate(hw:HWND;wp:WPARAM;lp:LPARAM):LRESULT;
var re:RECT;
var ite:TCITEMW;
var cuantos:Integer;
begin
  if GetClientRect(hw, @re) = false then
     MiMostrarError(WideString({$INCLUDE %FILE%}), WideString({$INCLUDE %LINE%}));
  htabcontrol := CreateWindowExW(0, WC_TABCONTROL, PWideChar(''),
        WS_VISIBLE or WS_CHILD, SEPARACIONMD, SEPARACIONMD,
        re.right - (SEPARACIONMD * 2), re.bottom - (SEPARACIONMD * 4),
        hw, 0, GetModuleHandle(nil), nil);
  if (htabcontrol = 0) then
     MiMostrarError(WideString({$INCLUDE %FILE%}), WideString({$INCLUDE %LINE%}));
  MiPonerFuenteGui(htabcontrol);
  ite.mask := TCIF_TEXT;
  ite.pszText :=  IdiomasObtenerTexto(35);
  if (SendMessageW(htabcontrol, TCM_INSERTITEMW, IDTABANIADIR, LPARAM(@ite)) = -1) then
    MiMostrarError(WideString({$INCLUDE %FILE%}), WideString({$INCLUDE %LINE%}));

  ite.pszText :=  IdiomasObtenerTexto(36);
  if (SendMessageW(htabcontrol, TCM_INSERTITEMW, IDTABBORRAR, LPARAM(@ite)) = -1) then
    MiMostrarError(WideString({$INCLUDE %FILE%}), WideString({$INCLUDE %LINE%}));

  if SendMessage(htabcontrol, TCM_SETCURSEL, 0, 0) = -1 then
    MiMostrarError(WideString({$INCLUDE %FILE%}), WideString({$INCLUDE %LINE%}));


  hstatic1 := CreateWindowExW(0, PWideChar('static'), IdiomasObtenerTexto(1000005),
        WS_VISIBLE or WS_CHILD, SEPARACIONMD * 2, SEPARACIONMD * 3,
        re.right - (SEPARACIONMD * 4), (SEPARACIONMD),
        hw, 0, GetModuleHandle(nil), nil);
  if (hstatic1 = 0) then
     MiMostrarError(WideString({$INCLUDE %FILE%}), WideString({$INCLUDE %LINE%}));
  MiPonerFuenteGui(hstatic1);

  hedcontrol := CreateWindowExW(WS_EX_CLIENTEDGE, PWideChar('edit'), PWideChar(''),
        WS_VISIBLE or WS_CHILD, SEPARACIONMD * 3, SEPARACIONMD * 4,
        re.right - (SEPARACIONMD * 5), (SEPARACIONMD),
        hw, 0, GetModuleHandle(nil), nil);
  if (hedcontrol = 0) then
     MiMostrarError(WideString({$INCLUDE %FILE%}), WideString({$INCLUDE %LINE%}));
  MiPonerFuenteGui(hedcontrol);
  SendMessageW(hedcontrol, EM_SETLIMITTEXT, 250, 0);

  hgrupbox := CreateWindowExW(0, PWideChar('Button'), IdiomasObtenerTexto(1000006),
        BS_GROUPBOX or WS_VISIBLE or WS_CHILD, SEPARACIONMD * 2,
        SEPARACIONMD * 6,
        re.Right - (SEPARACIONMD * 4), (SEPARACIONMD * 5),
        hw, 0, GetModuleHandle(nil), nil);
  if hgrupbox = 0 then
    MiMostrarError(WideString({$INCLUDE %FILE%}), WideString({$INCLUDE %LINE%}));
  MiPonerFuenteGui(hgrupbox);

  hfecbot  := CreateWindowExW(0, PWideChar('Button'), IdiomasObtenerTexto(1000007),
        BS_AUTORADIOBUTTON or WS_VISIBLE or WS_CHILD or WS_GROUP,
        SEPARACIONMD * 3,
        SEPARACIONMD * 7, SEPARACIONMD * 10, SEPARACIONMD,
        hw, 0, GetModuleHandle(nil), nil);
  if hfecbot = 0 then
    MiMostrarError(WideString({$INCLUDE %FILE%}), WideString({$INCLUDE %LINE%}));
  MiPonerFuenteGui(hfecbot);

  hwdatepick1 := CreateWindowExW(0, DATETIMEPICK_CLASS, PWideChar(''),
        DTS_LONGDATEFORMAT or WS_VISIBLE or WS_CHILD,
        (re.Right - ANCHODATE)  - (SEPARACIONMD * 4) - ANCHOTIME,
        SEPARACIONMD * 7, ANCHODATE, SEPARACIONMD,
        hw, 0, GetModuleHandle(nil), nil);
  if hwdatepick1 = 0 then
    MiMostrarError(WideString({$INCLUDE %FILE%}), WideString({$INCLUDE %LINE%}));
  MiPonerFuenteGui(hwdatepick1);

  hwdatepick2 := CreateWindowExW(0, DATETIMEPICK_CLASS, PWideChar(''),
        DTS_TIMEFORMAT or WS_VISIBLE or WS_CHILD,
        (re.Right - ANCHOTIME)  - (SEPARACIONMD * 3),
        SEPARACIONMD * 7, ANCHOTIME, SEPARACIONMD,
        hw, 0, GetModuleHandle(nil), nil);
  if hwdatepick2 = 0 then
    MiMostrarError(WideString({$INCLUDE %FILE%}), WideString({$INCLUDE %LINE%}));
  MiPonerFuenteGui(hwdatepick2);

  hultnoch  := CreateWindowExW(0, PWideChar('Button'), IdiomasObtenerTexto(1000008),
        BS_AUTORADIOBUTTON or WS_VISIBLE or WS_CHILD,
        SEPARACIONMD * 3,
        SEPARACIONMD * 9, SEPARACIONMD * 10, SEPARACIONMD,
        hw, 0, GetModuleHandle(nil), nil);
  if hultnoch = 0 then
    MiMostrarError(WideString({$INCLUDE %FILE%}), WideString({$INCLUDE %LINE%}));
  MiPonerFuenteGui(hultnoch);


  hbotacep  := CreateWindowExW(0, PWideChar('Button'), IdiomasObtenerTexto(28),
        BS_PUSHBUTTON or WS_VISIBLE or WS_CHILD,
        (ANCHOVENTANAMD - (ANCHOBOTONMD * 2)) DIV 3,
        re.Bottom - SEPARACIONMD * 2,
        ANCHOBOTONMD, SEPARACIONMD,
        hw, IDBOTONACEPTAR, GetModuleHandle(nil), nil);
  if hbotacep = 0 then
    MiMostrarError(WideString({$INCLUDE %FILE%}), WideString({$INCLUDE %LINE%}));
  MiPonerFuenteGui(hbotacep);

  hbotcanc  := CreateWindowExW(0, PWideChar('Button'), IdiomasObtenerTexto(33),
        BS_PUSHBUTTON or WS_VISIBLE or WS_CHILD,

        ((ANCHOVENTANAMD - (ANCHOBOTONMD * 2)) DIV 3) * 2 + ANCHOBOTONMD,
        re.Bottom - SEPARACIONMD * 2,
        ANCHOBOTONMD, SEPARACIONMD,
        hw, IDBOTONCANCELAR, GetModuleHandle(nil), nil);
  if hbotcanc = 0 then
    MiMostrarError(WideString({$INCLUDE %FILE%}), WideString({$INCLUDE %LINE%}));
  MiPonerFuenteGui(hbotcanc);

  SendMessageW(hfecbot, BM_SETCHECK, BST_CHECKED, 0);

hstatic2 := CreateWindowExW(0, PWideChar('static'), IdiomasObtenerTexto(1000011),
        WS_VISIBLE or WS_CHILD, SEPARACIONMD * 2, SEPARACIONMD * 3,
        re.right - (SEPARACIONMD * 4), (SEPARACIONMD),
        hw, 0, GetModuleHandle(nil), nil);
  if (hstatic2 = 0) then
     MiMostrarError(WideString({$INCLUDE %FILE%}), WideString({$INCLUDE %LINE%}));
  MiPonerFuenteGui(hstatic2);

  hcombobox := CreateWindowExW(0, WC_COMBOBOX, PWideChar(''),
        CBS_DROPDOWNLIST or CBS_HASSTRINGS or WS_VISIBLE or WS_CHILD or WS_VSCROLL,
        SEPARACIONMD * 3, SEPARACIONMD * 4,
        re.right - (SEPARACIONMD * 5), (SEPARACIONMD * 6),
        hw, 0, GetModuleHandle(nil), nil);
  if (hcombobox = 0) then
     MiMostrarError(WideString({$INCLUDE %FILE%}), WideString({$INCLUDE %LINE%}));
  MiPonerFuenteGui(hcombobox);
  sqAniadirAComboBoxEliminar(hcombobox);

  cuantos := SendMessageW(hcombobox, CB_GETCOUNT, 0, 0);
  if cuantos = CB_ERR then
    MiMostrarError(WideString({$INCLUDE %FILE%}), WideString({$INCLUDE %LINE%}));
  if cuantos > 0 then
  begin
    if SendMessageW(hcombobox, CB_SETCURSEL, 0, 0) = CB_ERR then
      MiMostrarError(WideString({$INCLUDE %FILE%}), WideString({$INCLUDE %LINE%}));
  end;

  mdMostrarAniadir(SW_SHOW);
  mdMostrarBorrar(SW_HIDE);


  wp := wp;
  lp := lp;
  Exit(0);
end;
{----------------------------------------------------------}
function mdfunciondeventana(hwnd:HWND;mensaje:UINT;wp:WPARAM;lp:LPARAM):LRESULT;stdcall;
begin
  if mensaje = WM_DESTROY then
  begin
    PostQuitMessage(0);
    Exit(0);
  end;
  if mensaje = WM_CREATE then
    Exit(mdOnCreate(hwnd, wp, lp));
  if mensaje = WM_COMMAND then
    Exit(mdOnCommand(hwnd, wp, lp));
  if mensaje = WM_NOTIFY then
    Exit(mdOnNotify(hwnd, wp, lp));

  Exit(DefWindowProcW(hwnd, mensaje, wp, lp));
end;
{--------------------------------------------------------}
procedure mdmanejarFechas(hvenmad:HWND);
  var
  hw:HWND;
  wc:WNDCLASSEX;
  hig:HICON;
  hiq:HICON;
  hc:HCURSOR;
  ws:WideString;
  ancho:Integer;
  alto:Integer;
  hins:HMODULE;
  begin
  ws := 'joseprinttool2';
  EnableWindow(hvenmad, FALSE);
  hins := GetModuleHandle(nil);
  if hins = 0 then
    MiMostrarError(WideString({$INCLUDE %FILE%}),  WideString({$INCLUDE %LINE%}));
  hig := LoadIconW(GetModuleHandle(nil), PWideChar(9999));
  hiq := LoadIconW(GetModuleHandle(nil), PWideChar(10000));
  if (hig = 0) or (hiq = 0) then
    MiMostrarError(WideString({$INCLUDE %FILE%}), WideString({$INCLUDE %LINE%}));
  hc := LoadCursor(0, IDC_ARROW);
  if hc = 0 then
    MiMostrarError(WideString({$INCLUDE %FILE%}), WideString({$INCLUDE %LINE%}));
  MiSetWindowClass(@wc, CS_HREDRAW Or CS_VREDRAW, @mdfunciondeventana,
                           hig, hc, HBRUSH(COLOR_BTNFACE + 1),
                           nil, PWideChar(ws),
                           hiq);
  ancho := ANCHOVENTANAMD;
  alto := ALTOVENTANAMD;
  MiAjustarACliente(ancho, alto);
  hw := CreateWindowExW(0, PWideChar(ws), IdiomasObtenerTexto(1000004),
                       WS_CAPTION Or WS_SYSMENU,
                       CW_USEDEFAULT, CW_USEDEFAULT,
                       ancho, alto,
                       hvenmad, 0, hins, nil);
  if hw = 0 then
    MiMostrarError(WideString({$INCLUDE %FILE%}),  WideString({$INCLUDE %LINE%}));
  if MoveWindow(hw,
             LongInt((GetSystemMetrics(SM_CXMAXIMIZED)- ancho)div 2),
             LongInt((GetSystemMetrics(SM_CYMAXIMIZED) - alto) div 2),
             ancho, alto, TRUE) = LongBool(0) then
    MiMostrarError(WideString({$INCLUDE %FILE%}),  WideString({$INCLUDE %LINE%}));
  ShowWindow(hw, SW_SHOW);
  MiBucleMensajes();
  if UnregisterClassW(PWideChar(ws), GetModuleHandle(nil)) = false then
    MiMostrarError(WideString({$INCLUDE %FILE%}), WideString({$INCLUDE %LINE%}));
  EnableWindow(hvenmad, TRUE);
  SetForegroundWindow(hvenmad);
end;

end.

