unit misqlite;

interface




uses windows, funcionessueltas, winspool, sysutils, commctrl, milibreria;

procedure sqLlenarListaImpresoras(hw:HWND;fech:SYSTEMTIME;campo:PWideChar);
function sqObtenerFechaDeDescripcion(var fech:SYSTEMTIME;descr:PWideChar):boolean;
function sqAbrirdb():PVOID;
procedure sqCerrardb( psqlite:PVOID);
procedure sqAniadirDato(info:PVOID);
procedure sqAniadirFecha(var fech:SYSTEMTIME;descr:PWideChar);
procedure sqAniadirAComboBox(hwcb:HWND);
procedure sqAniadirAComboBoxEliminar(hwcb:HWND);
procedure sqQuitarFecha(descr:PWideChar);

const
  SQLITE_OK = 0;
  SQLITE_BUSY = 5;
  SQLITE_ROW = 100;
  SQLITE_DONE = 101;

var puedo:HANDLE;
implementation

  function sqlite3_open16(namedb:PWideChar;psq:PVOID):Integer;cdecl;external 'sqlite3.dll';
  function sqlite3_close(psq:PVOID):Integer;cdecl;external 'sqlite3.dll';
  function sqlite3_prepare16_v2(psq:PVOID;zsql:PWideChar;nbyt:Integer;ppstm:PVOID;pzt:PVOID):Integer;cdecl;external 'sqlite3.dll';
  function sqlite3_bind_text16(pstm:PVOID;ic:Integer;val:PVOID;nbs:Integer;fd:PVOID):Integer;cdecl;external 'sqlite3.dll';
  function sqlite3_step(pstm:PVOID):Integer;cdecl;external 'sqlite3.dll';
  function sqlite3_column_text16(pstm:PVOID;ic:Integer):PVOID;cdecl;external 'sqlite3.dll';
  function sqlite3_finalize(pstm:PVOID):Integer;cdecl;external 'sqlite3.dll';
{----------------------------------------------}
procedure sqLlenarListaImpresoras(hw:HWND;fech:SYSTEMTIME;campo:PWideChar);
  var psqlite:PVOID;
  var fecha:array [0..100] of WideChar;
  var orden:array [0..1000] of WideChar;
  var cad:array [0..200] of WideChar;
  var pstm:PVOID;
  var pnu:PVOID;
 // var printer:PWideChar;
 // var hojas:WideString;
 // var x:integer;
  var lvi:LVITEMW;
  var ni:integer;
 // var ansis:string;
  var retorno:integer;
 // var largo:integer;
begin
  if SendMessageW(hw, LVM_DELETEALLITEMS, 0, 0) = 0 then
     mostrarerror(WideString({$INCLUDE %FILE%}), WideString({$INCLUDE %LINE%}));

  fecha := Format('%.4d-%.2d-%.2dT%.2d:%.2d:%.2d.%.3d', [fech.wYear, fech.wMonth, fech.wDay,
           fech.wHour, fech.wMinute, fech.wSecond, fech.wMilliseconds]);
  //fecha := Format('%.4d-%.2d-%.2dT00:00:00.000' , [fech.wYear, fech.wMonth, fech.wDay]);
  psqlite := sqAbrirdb();
  orden := WideString('select ') + WideString(campo) + WideString(', sum(trnumpags), count(trnumpags) from ');
  orden := orden + WideString('tbTrabajos where julianday(trfecha) ');//julianday(trfecha) ');
  orden := orden + WideString('>= julianday(''');
  orden := orden + fecha;
  orden := orden + WideString(''') group by ') + WideString(campo) + WideString(';');
  orden := orden + WideChar(0);
  //MessageBoxW(0, PWideChar(orden), PWideChar(campo), MB_OK);
  retorno := SQLITE_BUSY;
  while retorno = SQLITE_BUSY do
  begin
  retorno := sqlite3_prepare16_v2(psqlite, PWideChar(orden), (lstrlenW(PWideChar(orden)) + 1) * 2, @pstm, @pnu);
  Sleep(90);
  end;
  if retorno  <> SQLITE_OK then
    mostrarerror(WideString({$INCLUDE %FILE%}), WideString({$INCLUDE %LINE%}));
  while true = true do
  begin
    retorno := SQLITE_BUSY;
    while retorno = SQLITE_BUSY do
    begin

    retorno := sqlite3_step(pstm);
    Sleep(90);
    end;
    if retorno = SQLITE_DONE then
    begin
      sqlite3_finalize(pstm);
      sqCerrardb(psqlite);
      exit();
    end;
    if retorno = SQLITE_ROW then
    begin
      ni := SendMessage(hw, LVM_GETITEMCOUNT, 0, 0);
      lvi.iItem := ni;
      lvi.iSubItem := 0;
      lvi.pszText := sqlite3_column_text16(pstm, Integer(0));
      lvi.cchTextMax := Miwcslen(sqlite3_column_text16(pstm, Integer(1))) + 1;
      lvi.mask := LVIF_TEXT;
      if SendMessage(hw, LVM_INSERTITEMW, 0, LongInt(@lvi)) = -1 then
        mostrarerror(WideString({$INCLUDE %FILE%}), WideString({$INCLUDE %LINE%}));
      lvi.iSubItem := 1;
      Miwcscpy(cad, sqlite3_column_text16(pstm, Integer(1)));
      lvi.pszText := cad;
      lvi.cchTextMax := Miwcslen(cad) + 1;
      if SendMessage(hw, LVM_SETITEMW, 0, LongInt(@lvi)) = -1 then
        mostrarerror(WideString({$INCLUDE %FILE%}), WideString({$INCLUDE %LINE%}));
      lvi.iSubItem := 2;
      Miwcscpy(cad, sqlite3_column_text16(pstm, Integer(2)));
      lvi.pszText := cad;
      lvi.cchTextMax := Miwcslen(cad) + 1;
      if SendMessage(hw, LVM_SETITEMW, 0, LongInt(@lvi)) = -1 then
        mostrarerror(WideString({$INCLUDE %FILE%}), WideString({$INCLUDE %LINE%}));
    end;
  end;
end;
  {--------------------------------------------}
  procedure sqAniadirDato(info:PVOID);
  var pji:^JOB_INFO_2W;
  var x:Integer;
//  var cadena:String;
  var tl:SYSTEMTIME;
  var orden:array [0..1000] of WideChar;
  var fecha:array [0..100] of WideChar;
  var pstm:PVOID;
  var pnu:PVOID;
  var psqlite:PVOID;
  var pgs:DWORD;
  var retorno:Integer;
  begin
    psqlite := sqAbrirdb();
    pji := info;
    SystemTimeToTzSpecificLocalTime(nil, @pji^.Submitted, @tl);
    orden := WideString('insert into tbTrabajos (trfecha,');
    orden := orden + WideString('trusuario,');
    orden := orden + WideString('trmaquina, trimpresora,');
    orden := orden + WideString('trnumpags) values (');
    fecha := Format('%.4d-%.2d-%.2dT%.2d:%.2d:%.2d.%.3d', [tl.wYear, tl.wMonth, tl.wDay,
             tl.wHour, tl.wMinute, tl.wSecond, tl.wMilliseconds]);
    orden := orden + '''' + fecha + '''' + ',';
    orden := orden + '''' +  pji^.pUserName + '''' + ',';
    orden := orden + '''' + pji^.pMachineName + '''' + ',';
    orden := orden + '''' + pji^.pPrinterName + '''' + ',';
    if pji^.PagesPrinted = 0 then
      pgs := pji^.TotalPages
    else
      pgs := pji^.PagesPrinted;
    if (pji^.pDevMode^.dmFields and DM_COPIES) <> 0 then
      x := Integer(pgs) * pji^.pDevMode^.dmCopies
    else
      x := Integer(pgs);
    orden := orden + WideString(IntToStr(x)) + ');';
    retorno := SQLITE_BUSY;
    while retorno = SQLITE_BUSY do
    begin
    retorno := sqlite3_prepare16_v2(psqlite, PWideChar(orden), (lstrlenW(PWideChar(orden)) + 1) * 2, @pstm, @pnu);
      Sleep(90);
      end;
    if retorno  <> SQLITE_OK then
      mostrarerror(WideString({$INCLUDE %FILE%}), WideString({$INCLUDE %LINE%}));
    retorno := SQLITE_BUSY;
    while retorno = SQLITE_BUSY do
    begin
      retorno := sqlite3_step(pstm);
      Sleep(90);
    end;
    if retorno  <> SQLITE_DONE then
      mostrarerror(WideString({$INCLUDE %FILE%}), WideString({$INCLUDE %LINE%}));
    retorno := SQLITE_BUSY;
    while retorno = SQLITE_BUSY do
    begin
      Sleep(90);
      retorno := sqlite3_finalize(pstm);
    end;
    sqCerrardb(psqlite);
  end;
  {---------------------------------------------}
  function sqAbrirdb():PVOID;
    var DbNameW: Array [0..1000] of WideChar;
    var x:Integer;
    var orden:Array[0..1000] of WideChar;
    var pstm:PVOID;
    var pnu:PVOID;
    var yt:boolean;
    var yf:boolean;
    var psqlite:PVOID;
    var retorno : Integer;
  begin
    if GetModuleFileNameW(0, PWideChar(DbNameW), 599) = 0 then
      mostrarerror(WideString({$INCLUDE %FILE%}), WideString({$INCLUDE %LINE%}));
    for x := Miwcslen(PWideChar(WideString(DbNameW))) downto 0 do
    begin
      if DbNameW[x] = WideChar('\') then
      begin
        DbNameW[x + 1] := WideChar(0);
        break;
      end;
    end;
    DbNameW := DbNameW + WideString('joseprntool.db');
    retorno := SQLITE_BUSY;
    while retorno = SQLITE_BUSY do
    begin
      retorno := sqlite3_open16(PWideChar(DbNameW), @psqlite);
      Sleep(90);
    end;
    if retorno <> SQLITE_OK then
      mostrarerror(WideString({$INCLUDE %FILE%}), WideString({$INCLUDE %LINE%}));
    orden := WideString('Select name from sqlite_master where type = ''table'';');
    orden := orden + WideChar(0);
    retorno := SQLITE_BUSY;
   while retorno = SQLITE_BUSY do
   begin
     retorno := sqlite3_prepare16_v2(psqlite, PWideChar(orden), (lstrlenW(PWideChar(orden)) + 1) * 2 , @pstm, @pnu);
     Sleep(90);
   end;
   if retorno <> SQLITE_OK then
      mostrarerror(WideString({$INCLUDE %FILE%}), WideString({$INCLUDE %LINE%}));
    yt := false;
    yf := false;
    while true = true do
    begin
      x := SQLITE_BUSY;
      while x = SQLITE_BUSY do
      begin
        x := sqlite3_step(pstm);
        Sleep(90);
      end;
      if x = SQLITE_DONE then
      begin
        if (yt = true) and (yf = true) then
        begin
          sqlite3_finalize(pstm);
          Exit(psqlite);
        end;
        retorno := SQLITE_BUSY;
        while retorno = SQLITE_BUSY do
        begin
          retorno := sqlite3_finalize(pstm);
          Sleep(90);
        end;
        orden := WideString('create table if not exists tbTrabajos');
        orden := orden + WideString(' (trllapri Integer primary key autoincrement,');
        orden := orden + WideString('trfecha text,');
        orden := orden + WideString('trusuario text(100),');
        orden := orden + WideString('trmaquina text(100), trimpresora text(100),');
        orden := orden + WideString('trnumpags integer);');
        retorno := SQLITE_BUSY;
        while retorno = SQLITE_BUSY do
        begin
        retorno :=  sqlite3_prepare16_v2(psqlite, PWideChar(orden), (lstrlenW(PWideChar(orden)) + 1) * 2, @pstm, @pnu);
          Sleep(90);
        end;
        if retorno <> SQLITE_OK then
          mostrarerror(WideString({$INCLUDE %FILE%}), WideString({$INCLUDE %LINE%}));
        retorno := SQLITE_BUSY;
        while retorno = SQLITE_BUSY do
        begin
          retorno :=  sqlite3_step(pstm);
          Sleep(90);
        end;
        if retorno <> SQLITE_DONE then
          mostrarerror(WideString({$INCLUDE %FILE%}), WideString({$INCLUDE %LINE%}));
        retorno := SQLITE_BUSY ;
        while retorno = SQLITE_BUSY do
        begin
        retorno := sqlite3_finalize(pstm);
        end;
        orden := WideString('create table if not exists tbFechas ');
        orden := orden + WideString('(fellapri integer primary key autoincrement,');
        orden := orden + WideString('fefecha text,');
        orden := orden + WideString('fememo text(261) );');
        retorno := SQLITE_BUSY;
        while retorno = SQLITE_BUSY do
        begin
        retorno :=  sqlite3_prepare16_v2(psqlite, PWideChar(orden), (lstrlenW(PWideChar(orden)) + 1) * 2, @pstm, @pnu);
        Sleep(90);
        end;
        if retorno  <> SQLITE_OK then
          mostrarerror(WideString({$INCLUDE %FILE%}), WideString({$INCLUDE %LINE%}));
        retorno := SQLITE_BUSY;
        while retorno = SQLITE_BUSY do
        begin
          retorno := sqlite3_step(pstm);
          Sleep(90);
        end;
        if retorno <> SQLITE_DONE then
          mostrarerror(WideString({$INCLUDE %FILE%}), WideString({$INCLUDE %LINE%}));
        retorno := SQLITE_BUSY;
        while retorno = SQLITE_BUSY do
        begin
          retorno := sqlite3_finalize(pstm);
          Sleep(90);
        end;
        Exit(psqlite);
      end;
      if x = SQLITE_ROW then
      begin
        if Miwcscmp(sqlite3_column_text16(pstm, Integer(0)), WideString('tbTrabajos')) = 0 then
          yt := true;
        if Miwcscmp(sqlite3_column_text16(pstm, Integer(0)), WideString('tbFechas')) = 0 then
          yf := true;
      end;
    end;
    retorno := SQLITE_BUSY;
    while retorno = SQLITE_BUSY do
    begin
      Sleep(90);
      retorno := sqlite3_finalize(pstm);
    end;
    Exit(psqlite);
  end;
{----------------------------------------------------}
procedure sqCerrardb( psqlite:PVOID);
begin
  if sqlite3_close(psqlite) <> SQLITE_OK then
    MiMostrarError(WideString({$INCLUDE %FILE%}), WideString({$INCLUDE %LINE%}));
end;
function sqObtenerFechaDeDescripcion(var fech:SYSTEMTIME;descr:PWideChar):boolean;
    var psqlite:PVOID;
    var fecha:array [0..100] of WideChar;
    var orden:array [0..1000] of WideChar;
    var pstm:PVOID;
    var pnu:PVOID;
    var retorno:integer;
    var d1:integer;
    var d2:integer;
    var d3:integer;
    var d4:integer;
    var d5:integer;
    var d6:integer;
    var d7:integer;
  begin
    psqlite := sqAbrirdb();
    orden := WideString('select fefecha from tbFechas where fememo = ''') + WideString(descr) + WideString(''';');
    orden := orden + WideChar(0);
    retorno := sqlite3_prepare16_v2(psqlite, PWideChar(orden), (Miwcslen(PWideChar(orden)) + 1) * 2, @pstm, @pnu);
    if retorno  <> SQLITE_OK then
      MiMostrarError(WideString({$INCLUDE %FILE%}), WideString({$INCLUDE %LINE%}));
    retorno := sqlite3_step(pstm);
    if retorno = SQLITE_DONE then
    begin
      sqlite3_finalize(pstm);
      sqCerrardb(psqlite);
      exit(false);
    end;
    if retorno = SQLITE_ROW then
    begin
      Miwcscpy(fecha, sqlite3_column_text16(pstm, Integer(0)));
      sscanf(fecha, '%d-%d-%dT%d:%d:%d.%d', [@d1, @d2, @d3, @d4, @d5, @d6, @d7]);
      fech.wYear:= d1;
      fech.wMonth:= d2;
      fech.wDay:= d3;
      fech.wHour:= d4;
      fech.wMinute:= d5;
      fech.wSecond:= d6;
      fech.wMilliseconds:= d7;
      sqlite3_finalize(pstm);
      sqCerrardb(psqlite);
      exit(true);
    end;
    MiMostrarError(WideString({$INCLUDE %FILE%}), WideString({$INCLUDE %LINE%}));
  end;
  procedure sqAniadirFecha(var fech:SYSTEMTIME;descr:PWideChar);
  var orden:array [0..1000] of WideChar;
  var fecha:array [0..100] of WideChar;
  var pstm:PVOID;
  var pnu:PVOID;
  var psqlite:PVOID;
  var retorno:Integer;
  begin
    psqlite := sqAbrirdb();
    orden := WideString('insert into tbFechas (fefecha, fememo)');
    orden := orden + WideString(' values (');
    fecha := Format('%.4d-%.2d-%.2dT%.2d:%.2d:%.2d.%.3d', [fech.wYear,
             fech.wMonth, fech.wDay,
             fech.wHour, fech.wMinute, fech.wSecond, fech.wMilliseconds]);
    orden := orden + WideString('''') + fecha + WideString('''') ;
    orden := orden + WideString(', ') + WideString('''') + descr + WideString('''') + WideString(');');
    retorno := sqlite3_prepare16_v2(psqlite, PWideChar(orden), (Miwcslen(PWideChar(orden)) + 1) * 2, @pstm, @pnu);
    if retorno  <> SQLITE_OK then
      MiMostrarError(WideString({$INCLUDE %FILE%}), WideString({$INCLUDE %LINE%}));
    retorno := sqlite3_step(pstm);
    if retorno  <> SQLITE_DONE then
      MiMostrarError(WideString({$INCLUDE %FILE%}), WideString({$INCLUDE %LINE%}));
    sqlite3_finalize(pstm);
    sqCerrardb(psqlite);
  end;
  procedure sqAniadirAComboBox(hwcb:HWND);
    var psqlite:PVOID;
    var orden:array [0..1000] of WideChar;
    var pstm:PVOID;
    var pnu:PVOID;
    var retorno:integer;
  begin
    psqlite := sqAbrirdb();
    orden := WideString('select fememo from tbFechas order by fememo;');
    orden := orden + WideChar(0);
    retorno := sqlite3_prepare16_v2(psqlite, PWideChar(orden), (lstrlenW(PWideChar(orden)) + 1) * 2, @pstm, @pnu);
    if retorno  <> SQLITE_OK then
      MiMostrarError(WideString({$INCLUDE %FILE%}), WideString({$INCLUDE %LINE%}));
    while true = true do
    begin
      retorno := sqlite3_step(pstm);
      if retorno = SQLITE_DONE then
      begin
        sqlite3_finalize(pstm);
        sqCerrardb(psqlite);
        exit();
      end;
      if retorno = SQLITE_ROW then
      begin
        if SendMessageW(hwcb, CB_ADDSTRING, 0, LongInt(sqlite3_column_text16(pstm, Integer(0)))) = CB_ERR then
          MiMostrarError(WideString({$INCLUDE %FILE%}), WideString({$INCLUDE %LINE%}));
        continue;
      end;
      MiMostrarError(WideString({$INCLUDE %FILE%}), WideString({$INCLUDE %LINE%}));
    end;
  end;
{-------------------------------------------------------------}
  procedure sqAniadirAComboBoxEliminar(hwcb:HWND);
    var psqlite:PVOID;
    var orden:array [0..1000] of WideChar;
    var pstm:PVOID;
    var pnu:PVOID;
    var retorno:integer;
  begin
    SendMessageW(hwcb, CB_RESETCONTENT, 0, 0);
    psqlite := sqAbrirdb();
    orden := WideString('select fememo from tbFechas order by fememo;');
    orden := orden + WideChar(0);
    retorno := sqlite3_prepare16_v2(psqlite, PWideChar(orden), (lstrlenW(PWideChar(orden)) + 1) * 2, @pstm, @pnu);
    if retorno  <> SQLITE_OK then
      MiMostrarError(WideString({$INCLUDE %FILE%}), WideString({$INCLUDE %LINE%}));
    while true = true do
    begin
      retorno := sqlite3_step(pstm);
      if retorno = SQLITE_DONE then
      begin
        sqlite3_finalize(pstm);
        sqCerrardb(psqlite);
        exit();
      end;
      if retorno = SQLITE_ROW then
      begin
        if SendMessageW(hwcb, CB_ADDSTRING, 0, LongInt(sqlite3_column_text16(pstm, Integer(0)))) = CB_ERR then
          MiMostrarError(WideString({$INCLUDE %FILE%}), WideString({$INCLUDE %LINE%}));
        continue;
      end;
      MiMostrarError(WideString({$INCLUDE %FILE%}), WideString({$INCLUDE %LINE%}));
    end;
  end;

  procedure sqQuitarFecha(descr:PWideChar);
  var orden:array [0..1000] of WideChar;
  var pstm:PVOID;
  var pnu:PVOID;
  var psqlite:PVOID;
  var retorno:Integer;
  begin
    psqlite := sqAbrirdb();
    orden := WideString('delete from tbFechas where fememo = ''');
    orden := orden + descr + WideString('''') + WideString(';');
    retorno := sqlite3_prepare16_v2(psqlite, PWideChar(orden), (Miwcslen(PWideChar(orden)) + 1) * 2, @pstm, @pnu);
    if retorno  <> SQLITE_OK then
      MiMostrarError(WideString({$INCLUDE %FILE%}), WideString({$INCLUDE %LINE%}));
    retorno := sqlite3_step(pstm);
    if retorno  <> SQLITE_DONE then
      MiMostrarError(WideString({$INCLUDE %FILE%}), WideString({$INCLUDE %LINE%}));
    sqlite3_finalize(pstm);
    sqCerrardb(psqlite);
  end;


end.

